SystemOrganization addCategory: #'UnixMetaStack-Profiling-TargetScript'!

Object subclass: #ProfilingTargetScript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling-TargetScript'!

ProfilingTargetScript class
	instanceVariableNames: 'packageNamesToSuitesDict'!

ProfilingTargetScript class
	instanceVariableNames: 'packageNamesToSuitesDict'!

!ProfilingTargetScript class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 14:49'!
allPackageTests

	^ packageNamesToSuitesDict keys printString! !

!ProfilingTargetScript class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2014 12:36'!
format: testResults

	^ { 
		#run-> testResults runCount .  
		#passes-> testResults expectedPassCount.
		#skipped-> testResults skippedCount .
		#expectedFailures-> testResults expectedDefectCount .
		#failures-> testResults unexpectedFailureCount .
		#errors-> testResults unexpectedErrorCount.
		#unExpectedPasses-> testResults unexpectedPassCount.
	   } asString! !

!ProfilingTargetScript class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2014 11:50'!
initialize

	super initialize.

	packageNamesToSuitesDict := Dictionary new.
	TestCase allSubclasses do: [ :testCase | 
			|testCollection|
			testCollection := packageNamesToSuitesDict 
									at: testCase package name asString
									ifAbsent: [ packageNamesToSuitesDict 
													at: testCase package name asString
													put: OrderedCollection new. ].
			testCollection add: testCase buildSuiteFromAllSelectors.
		]. 
	packageNamesToSuitesDict := packageNamesToSuitesDict collect:  [:value | (TestSuite new addTests: value) ].! !

!ProfilingTargetScript class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2014 12:27'!
run: aPackageTestNameAsString

	| success results |
	
	[ success := 
		((results := self runPackage: aPackageTestNameAsString) 
			defects isEmpty) ] 
	on: Error do: [ 
		success := false 
	].
	^ '__SUCCESS__START__{ #success -> ' , success printString , '. #resultsSummary ->' , (self format: results) , '}__SUCCESS__END__'! !

!ProfilingTargetScript class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/6/2014 16:13'!
run: aPackageTestNameAsString times: repeat

	| success results |
	
	[ success := 
		((results := self runPackage: aPackageTestNameAsString times: repeat)
			defects isEmpty) ] 
	on: Error do: [ 
		success := false 
	].
	^ '__SUCCESS__START__{ #success -> ' , success printString , '. #resultsSummary ->' , (self format: results) , '}__SUCCESS__END__'! !

!ProfilingTargetScript class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2014 11:29'!
runPackage: aPackageTestNameAsString

	^ (packageNamesToSuitesDict at: aPackageTestNameAsString) run! !

!ProfilingTargetScript class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/6/2014 16:47'!
runPackage: aPackageTestNameAsString times: repeat

	|results|
	
	(1 to: repeat) 
		do: [:i | results := (packageNamesToSuitesDict at: aPackageTestNameAsString) run]. 
		
	^ results"will return the last run results"! !
ProfilingTargetScript initialize!
